#include <iostream>
#include <iomanip>
using namespace std;

const int MAX_SIZE = 20;

void spiralWalk(int arr[][MAX_SIZE], int n, int m)
{
    int hor = 0, vert = 0, i,j=1;
    while(hor < n/2 && vert < m/2)
    {
        for(i = vert; i < m-vert; i++)
            {arr[hor][i]=j;j++;}

        for(i = hor+1; i < n-hor; i++)
            {arr[i][m-vert-1]=j;j++;}

        for(i = m-vert-2; i >= vert; i--)
            {arr[n-hor-1][i]=j;j++;}

        for(i = n-hor-2; i > hor; i--)
            {arr[i][vert]=j;j++;}

        ++hor;
        ++vert;
    }

    if(n <= m && n%2)
    {
        for(i = vert; i < m-vert; i++)
        {
            arr[hor][i]=j;j++;
        }
    }
    else if(m < n && m%2)
    {
        for(i = hor; i < n-hor; i++)
        {
            arr[i][vert]=j;j++;
        }
    }
}

void print(int arr[][MAX_SIZE], int n, int m)
{
    int i, j;
    for(i = 0; i < n; i++)
    {
        for(j = 0; j < m; j++)
        {
            cout << setw(5) << arr[i][j];
        }
        cout << endl;
    }
}

int main()
{ 
    int arr[MAX_SIZE][MAX_SIZE],a[MAX_SIZE];
    int b1,b,n, m, i, j,p,q;
    cin>>b;
    for(b1=1;b1<=b;b1++)
{
    cin >> n;
    cin >> m;

    cin >> p;
    cin >> q;

    spiralWalk(arr, n, m);
    a[b1]=arr[p-1][q-1];
}
    for(b1=1;b1<=b;b1++)
    cout<<a[b1]<<endl;
    return 0;
}
